DECLARE SUB lightFX (x%, y%, Bright%, Colr%)
DECLARE SUB AI (TA AS ANY, Nr%)
DECLARE SUB SPR2 (x%, y%, Nr%)
DECLARE SUB ScrollActor (TA AS ANY)
DECLARE SUB ShowActor (TA AS ANY)
DECLARE SUB Actors ()
DECLARE SUB Boden ()
DECLARE SUB SPR4 (x%, y%, Nr%)
DECLARE SUB SpritesLaden ()
DECLARE SUB Init ()
DECLARE SUB FrameRate ()
DEFINT A-Z
'$DYNAMIC
'$INCLUDE: 'directqb.bi'
'$INCLUDE: 'gslib.bi'
'$INCLUDE: 'xmslib.bi'

DIM SHARED hdl40 AS LONG, SPR20(402), SPR40(802)
DIM SHARED SX, SY, MAPXSize, MAPYSize, HMX AS SINGLE, HMY AS SINGLE, Etage
DIM SHARED layer, LightTable(0 TO 255), SetTable(0 TO 19, 0 TO 14)

TYPE ActorTYPE
Class AS INTEGER
XPos AS INTEGER
YPos AS INTEGER
XLen AS INTEGER
YLen AS INTEGER
GroupID AS INTEGER

LP AS INTEGER
Attack AS INTEGER
Armor AS INTEGER
Loyal AS INTEGER
Guts AS INTEGER

TAG1 AS INTEGER
TAG2 AS INTEGER
END TYPE

DIM SHARED Actor(0 TO 3, 1 TO 150) AS ActorTYPE

Init
MAPXSize = 60
MAPYSize = 60
REDIM SHARED Ma(0 TO 3, 1 TO MAPXSize, 1 TO MAPYSize) AS STRING * 5

Etage = 1

'a = DQBloadSound(1, "C:\MASTER\SOUNDS\APOGEE.WAV")
'DQBPlaySound 1, 1, 11025, 1

Actor(Etage, 1).Class = 1
Actor(Etage, 1).XLen = 20
Actor(Etage, 1).YLen = 20

'Ma(Etage, 7, 7).Obj = 1
'Ma(Etage, 7, 7).TAG1 = 1

DO
Boden
Actors
'This is the routine that can set color blending and make
'areas brighter/darker. Change the the values to change the effect.
'Works only with a 16 color gradient palette, but thats okay.
lightFX 100 - SX, 100 - SY, 2, 8

'Palette test, first color gradient (0-15) should is uneffected by
'lightFX, its for transp. (0) and fire (1-15)
FOR x = 0 TO 255
DQBpset B0, x, 0, x
NEXT

FrameRate
'Enable to sync with screenrefresh
'DQBwait 1
DQBcopyLayer B0, VIDEO
LOOP UNTIL DQBkey(1)

DQBclose
a = XmsDealloc(Handle)
SYSTEM

REM $STATIC
SUB Actors
DIM TA AS ActorTYPE 'Temporary Actor Object

Speed = 6
IF DQBkey(75) THEN HMX = HMX - Speed
IF DQBkey(72) THEN HMY = HMY - Speed
IF DQBkey(77) THEN HMX = HMX + Speed
IF DQBkey(80) THEN HMY = HMY + Speed

FOR D = 1 TO UBOUND(Actor)
IF Actor(Etage, D).Class = 0 THEN GOTO EndOfActorLoop
TA = Actor(Etage, D)
ShowActor TA
SELECT CASE TA.Class
CASE 1 'Hero
ScrollActor TA
TA.XPos = TA.XPos + HMX / 15
TA.YPos = TA.YPos + HMY / 15

CASE 2
AI TA, 1

END SELECT
Actor(Etage, D) = TA
EndOfActorLoop:
NEXT

HMX = HMX / 1.2
HMY = HMY / 1.2
END SUB

SUB AI (TA AS ActorTYPE, Nr)
SELECT CASE Nr
CASE 1
IF TA.XPos > Actor(Etage, 1).XPos THEN TA.XPos = TA.XPos - 1
IF TA.XPos < Actor(Etage, 1).XPos THEN TA.XPos = TA.XPos + 1
IF TA.YPos > Actor(Etage, 1).YPos THEN TA.YPos = TA.YPos - 1
IF TA.YPos < Actor(Etage, 1).YPos THEN TA.YPos = TA.YPos + 1


END SELECT
END SUB

SUB Boden
DQBpeek VARSEG(SPR40(0)), VARPTR(SPR40(0)), hdl40 + 1604 * 1, 1604
FOR XX = 0 TO (MAPXSize \ 2) - 1
FOR YY = 0 TO (MAPYSize \ 2) - 1
x = XX * 40
y = YY * 40
IF (x - SX) > -40 AND (x - SX) < 320 AND (y - SY) > -40 AND (y - SY) < 200 THEN Gssolidput x - SX, y - SY, layer, 0, VARSEG(SPR40(0)), VARPTR(SPR40(0))
NEXT
NEXT
END SUB

SUB FrameRate
STATIC FPS, frame, T!
frame = frame + 1
IF TIMER >= T! + 1 THEN
T! = TIMER
FPS = frame
frame = 0
END IF
DQBprint B0, STR$(FPS), 0, 0, 15
END SUB

SUB Init
RANDOMIZE TIMER
SCREEN 13
a = DQBinit(0, 32, 4098)

XmsApi
a = XmsAlloc(1024)

SpritesLaden
DQBinitVGA
DQBsetVolume 15
DQBinstallKeyboard

dummy& = SETMEM(-66000)
Seg0 = DQBsetBaseLayer(B0)
layer = DQBmapLayer(B0)
a = DQBinstallSB(FALSE, 32, 11025, AUTO, AUTO, AUTO)

S40SEG = VARSEG(SPR40(0))
S40PTR = VARPTR(SPR40(0))
S20SEG = VARSEG(SPR20(0))
S20PTR = VARPTR(SPR20(0))

SPR2 0, 0, 1
FOR x = 0 TO 19
FOR y = 0 TO 14
SetTable(x, y) = DQBpoint(B0, x, y)
NEXT
NEXT

OPEN "DAT/PALETTE.DAT" FOR BINARY AS #1
D = 1
FOR x = 0 TO 255
GET #1, D, r
D = D + 1
GET #1, D, g
D = D + 1
GET #1, D, b
D = D + 1
DQBsetCol x, r, g, b

DEF SEG = VARSEG(LightTable(x))
POKE VARPTR(LightTable(x)), x MOD 16
POKE VARPTR(LightTable(x)) + 1, x \ 16
DEF SEG

NEXT
CLOSE #1
END SUB

SUB lightFX (x, y, Bright, Colr)
DEF SEG = VARSEG(LightTable(c))
FOR XX = 0 TO 19
FOR YY = 0 TO 8
IF Bright = 0 THEN
Set = 1
ELSE
Set = SetTable(XX, YY)
IF Set = 0 GOTO SkipLight
END IF
c = DQBpoint(B0, XX + x, YY + y)
XL = PEEK(VARPTR(LightTable(c)))
YL = PEEK(VARPTR(LightTable(c)) + 1)
IF YL > 0 THEN XL = XL + Bright * Set
IF Colr > 0 THEN YL = Colr
IF XL > 15 THEN XL = 15
IF XL < 0 THEN XL = 0
DQBpset B0, XX + x, YY + y, XL + YL * 16
SkipLight:
NEXT
NEXT
DEF SEG
END SUB

SUB ScrollActor (TA AS ActorTYPE)
STATIC OldX, OldY
x = TA.XPos
y = TA.YPos
SSX = SX
SSY = SY
SSSX = SX
SSSY = SY
SSX = x + TA.XLen \ 2 - 160
SSY = y + TA.YLen \ 2 - 100
SX = CINT((SX * 9 + SSX * 1) / 10)
SY = CINT((SY * 9 + SSY * 1) / 10)
IF SX < 0 THEN SX = 0
IF SY < 0 THEN SY = 0
IF SX > MAPXSize * 20 - 320 THEN SX = MAPXSize * 20 - 320
IF SY > MAPYSize * 20 - 200 THEN SY = MAPYSize * 20 - 200
OldX = SSX
OldY = SSY
END SUB

SUB ShowActor (TA AS ActorTYPE)
SELECT CASE TA.Class
CASE 1: SPR4 TA.XPos - 10, TA.YPos - 20, 1
CASE 2: SPR2 TA.XPos, TA.YPos, 1


END SELECT
END SUB

SUB SPR2 (x, y, Nr)
IF (x - SX) < -19 OR (x - SX) > 319 OR (y - SY) < -19 OR (y - SY) > 199 THEN EXIT SUB
DQBpeek VARSEG(SPR20(0)), VARPTR(SPR20(0)), (Nr - 1) * 804, 804
DQBput B0, x - SX, y - SY, VARSEG(SPR20(0)), VARPTR(SPR20(0))
END SUB

SUB SPR4 (x, y, Nr)
IF (x - SX) < -39 OR (x - SX) > 319 OR (y - SY) < -39 OR (y - SY) > 199 THEN EXIT SUB
DQBpeek VARSEG(SPR40(0)), VARPTR(SPR40(0)), hdl40 + (Nr - 1) * 1604, 1604
DQBput B0, x - SX, y - SY, VARSEG(SPR40(0)), VARPTR(SPR40(0))
END SUB

SUB SpritesLaden
CLS
PRINT "loading sprites..."
Size = DQBsize(0, 0, 19, 19)
OPEN "DAT\MAIN20.SPL" FOR INPUT AS #1
DO
IF EOF(1) THEN EXIT DO
LINE INPUT #1, a$
DEF SEG = VARSEG(SPR20(0))
BLOAD "GFX\" + a$ + ".SPR", VARPTR(SPR20(0))
DEF SEG
DQBpoke VARSEG(SPR20(0)), VARPTR(SPR20(0)), hdl, Size
hdl = hdl + Size
cnt = cnt + 1
LOOP
CLOSE #1
hdl40 = hdl
PRINT LTRIM$(STR$(cnt)) + " 20x20 loaded."

cnt = 0
Size = DQBsize(0, 0, 39, 39)
OPEN "DAT\MAIN40.SPL" FOR INPUT AS #1
DO
IF EOF(1) THEN EXIT DO
LINE INPUT #1, a$
DEF SEG = VARSEG(SPR40(0))
BLOAD "GFX\" + a$ + ".SPR", VARPTR(SPR40(0))
DEF SEG
DQBpoke VARSEG(SPR40(0)), VARPTR(SPR40(0)), hdl, Size
hdl = hdl + Size
cnt = cnt + 1
LOOP
CLOSE #1
PRINT LTRIM$(STR$(cnt)) + " 40x40 loaded."
END SUB

